import router from './router'
import store from './store'
import {Message} from 'element-ui'
import NProgress from 'nprogress'
import 'nprogress/nprogress.css'
import {getToken} from '@/benyun/utils/auth'
import {isRelogin} from '@/benyun/utils/request'
import {getQueryString} from "@/benyun/utils/benyuntech";

NProgress.configure({ showSpinner: false })

// const whiteList = ['/login', '/demo', '/auth-redirect', '/bind', '/register']

const infoHandle = (to:any, next:any) => {
  isRelogin.show = true
  // 判断当前用户是否已拉取完user_info信息
  store.dispatch('GetInfo').then(() => {
    isRelogin.show = false
    store.dispatch('GenerateRoutes').then(accessRoutes => {
      // 根据roles权限生成可访问的路由表
      for(const item of accessRoutes){
        router.addRoute(item)
      }
      // router.addRoutes(accessRoutes) // 动态添加可访问路由表
      console.log(to)
      next({ ...to, replace: true }) // hack方法 确保addRoutes已完成
    })
  }).catch(err => {
      store.dispatch('LogOut').then(() => {
        Message.error(err)
        // next({ path: '/' })
      })
    })
}

router.beforeEach((to:any, from:any, next:any) => {
  NProgress.start()
  if (getToken()) {
    to.meta.title && store.dispatch('settings/setTitle', to.meta.title)
    /* has token*/
    // if (to.path === '/login') {
    //   next({ path: '/' })
    //   NProgress.done()
    // } else {
      if (store.getters.roles.length === 0) {
        infoHandle(to,next)
      } else {
        next()
      }
    // }
  } else {
    const ticket = getQueryString('ticket')
    const ssoToken = getQueryString('ssoToken')

    if(!ticket && !ssoToken){
      const redirect = location.origin
      // const redirect = location.href.replace(/\??ticket=[^&]*&?/g, '')
      location.href = `${process.env.VUE_APP_LOGIN_URL}?&redirect=${encodeURIComponent(redirect)}`
    }else{
      const url = ticket ? '/sso/doLoginByTicket' : '/sso/doLoginByToken'
      let data:any = {}
      if(ticket) {
        data.ticket = ticket
      }
      if(ssoToken) {
        data.token = ssoToken
      }
      store.dispatch('GetToken',{
        url,data
      }).then(() => {
        infoHandle(to,next)
        // location.href = '/index';
      }).catch((err:any) => {
        if(err && err.msg) {
          Message.error(err.msg);
        }
        // const redirect = location.href.replace(/\??ticket=[^&]*&?/g, '')
        const redirect = location.origin
        location.href = `${process.env.VUE_APP_LOGIN_URL}?&redirect=${encodeURIComponent(redirect)}`
      })
      // next()
    }
    

    // 没有token
    // if (whiteList.indexOf(to.path) !== -1) {
    //   // 在免登录白名单，直接进入
    //   next()
    // } else {
      
    //   next(`/login?redirect=${to.fullPath}`) // 否则全部重定向到登录页
    //   NProgress.done()
    // }
  }
})

router.afterEach(() => {
  NProgress.done()
})

